; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP (DATEN)														
;																				
EEPROM_READ_Z_PLUS_TEMP:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_READ_Z_PLUS_TEMP
	out EEARH, ZH	; ADRESSE						
	out EEARL, ZL
	sbi EECR,EERE	; Start eeprom read 			
	in temp,EEDR 	; Read data from Data Register	
	adiw ZL,1		; ADRESSE +1 					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
EEPROM_WRITE_Z_PLUS_TEMP:
	; muss EEPROM-Byte berschrieben werden	
	WDR
	push temp
	call EEPROM_READ_Z_PLUS_TEMP; read		
	sbiw ZL,1					; ADRESSE -1 
	mov R0,temp
	pop temp
	cp R0,temp
	brne EEPROM_WRITE_Z_TEMP_RUN
	adiw ZL,1					; ADRESSE +1 
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_Z_TEMP_RUN:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_PLUS_TEMP
	out EEARH, ZH	; Adresse								
	out EEARL, ZL	
	out EEDR,temp	; Write data							
	sbi EECR,EEMPE	; Write logical one to EEMPE			
	sbi EECR,EEPE 	; Start eeprom write by setting EEPE	
	adiw ZL,1		; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_LOAD:
	call LCD_CLEAR
	call TEXT_EEPROM
	call TEXT_READ
	call ZEILE2
;-------------------------------------------------------------------------------
	ldi ZL,LOW (0)						; Version			
	ldi ZH,HIGH(0)
	call EEPROM_READ_Z_PLUS_TEMP		; read				
	ldi temp1,(VERSION)
	cp temp,temp1
	brne EEPROM_WERKSEINSTELLUNG		; WERKSEINSTELLUNG	
;-------------------------------------------------------------------------------
	ldi XL,LOW (adr_VERSION)			; X=SRAM-ADRESSE	
	ldi XH,HIGH(adr_VERSION)
	ldi ZL,LOW (adr_EEPROM_SYSTEM_DATA)	; Z=EEPROM-ADRESSE	
	ldi ZH,HIGH(adr_EEPROM_SYSTEM_DATA)
	ldi YL,low (200)					; Anzahl			
	ldi YH,high(200)
;-------------------------------------------------------------------------------
EEPROM_SYSTEM_LADEN_s:
	WDR
	call EEPROM_READ_Z_PLUS_TEMP		; read				
	ST X+,temp
	sbiw YL,1							; Anzahl-1			
	tst YL
	brne EEPROM_SYSTEM_LADEN_s
	tst YH
	brne EEPROM_SYSTEM_LADEN_s
;-------------------------------------------------------------------------------
	; Anzahl Starts + 1			
	LDS temp1,(adr_ANZAHL_START_L)
	LDS temp2,(adr_ANZAHL_START_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_ANZAHL_START_L),temp1
	STS(adr_ANZAHL_START_H),temp2
	call WAIT_500ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_WERKSEINSTELLUNG:
	call LCD_CLEAR
	call TEXT_WERKSEINSTELLUNG
	call BEEP_LANG
	call WAIT_1s
	call EEPROM_SAVE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_SAVE:
	call LCD_CLEAR
	call TEXT_EEPROM
	call TEXT_SAVE
	call ZEILE2
;-------------------------------------------------------------------------------
	ldi XL,LOW (SRAM_START)					; X=SRAM-ADRESSE	
	ldi XH,HIGH(SRAM_START)
	ldi ZL,LOW (adr_EEPROM_SYSTEM_DATA)							; Z=EEPROM-ADRESSE	
	ldi ZH,HIGH(adr_EEPROM_SYSTEM_DATA)
	ldi YL,low (200)						; Anzahl			
	ldi YH,high(200)
;-------------------------------------------------------------------------------
EEPROM_SAVE_s:
	WDR
	LD temp,X+
	call EEPROM_WRITE_Z_PLUS_TEMP
	sbiw Yl,1						; Anzahl			
	tst YL
	brne EEPROM_SAVE_s
	tst YH
	brne EEPROM_SAVE_s
	call WAIT_500ms
	jmp LCD_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################


