; ##############################################################################
; ##############################################################################
; ##############################################################################
TCP_RX:
;-------------------------------------------------------------------------------
	; Checksum-Check				
	LDS temp3,(TCPchecksumL)
	LDS temp4,(TCPchecksumH)
	call MAKE_TCP_PSEUDOHEADER_CHECKSUM
	LDS temp1,(TCPchecksumL)
	LDS temp2,(TCPchecksumH)
	cp temp1,temp3
	brne TCP_RX_CRC_ERROR
	cp temp2,temp4
	brne TCP_RX_CRC_ERROR
	rjmp TCP_RX_CRC_OK
;-------------------------------------------------------------------------------
TCP_RX_CRC_ERROR:
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_L)	; Counter	
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_H),R1
	ldi temp,(ERROR_TCP_CRC)	
	call WARNUNG_SAVE_TEMP
;-------------------------------------------------------------------------------
TCP_RX_CRC_OK:
	; SPEICHERN fr ANZEIGE			
	LDS temp1,(SourceMACaddr0)
	LDS temp2,(SourceMACaddr1)
	LDS temp3,(SourceMACaddr2)
	LDS temp4,(SourceMACaddr3)
	LDS temp5,(SourceMACaddr4)
	LDS temp6,(SourceMACaddr5)
	STS(adr_TCP_RX_VIEW_SourceMACaddr0),temp1
	STS(adr_TCP_RX_VIEW_SourceMACaddr1),temp2
	STS(adr_TCP_RX_VIEW_SourceMACaddr2),temp3
	STS(adr_TCP_RX_VIEW_SourceMACaddr3),temp4
	STS(adr_TCP_RX_VIEW_SourceMACaddr4),temp5
	STS(adr_TCP_RX_VIEW_SourceMACaddr5),temp6
	; SPEICHERN fr ANZEIGE			
	LDS temp1,(IP4SourceIPaddr3)
	LDS temp2,(IP4SourceIPaddr2)
	LDS temp3,(IP4SourceIPaddr1)
	LDS temp4,(IP4SourceIPaddr0)
	STS(adr_TCP_RX_VIEW_IP4SourceIPaddr0),temp1
	STS(adr_TCP_RX_VIEW_IP4SourceIPaddr1),temp2
	STS(adr_TCP_RX_VIEW_IP4SourceIPaddr2),temp3
	STS(adr_TCP_RX_VIEW_IP4SourceIPaddr3),temp4
	; SPEICHERN fr ANZEIGE			
	LDS temp1,(TCPdestinationPortL)
	LDS temp2,(TCPdestinationPortH)
	STS(adr_TCP_RX_VIEW_TCP_PORT_DEST_L),temp1
	STS(adr_TCP_RX_VIEW_TCP_PORT_DEST_H),temp2
	; SPEICHERN fr ANZEIGE			
	LDS temp1,(TCPsourcePortL)
	LDS temp2,(TCPsourcePortH)
	STS(adr_TCP_RX_VIEW_TCP_PORT_SOURCE_L),temp1
	STS(adr_TCP_RX_VIEW_TCP_PORT_SOURCE_H),temp2
	; SPEICHERN fr ANZEIGE			
	LDS temp,(TCPflags)
	STS(adr_TCP_RX_VIEW_TCP_FLAGS),temp
;-------------------------------------------------------------------------------
; nur freigegebene PORTS														
TCP_PORT_A:
	LDS temp1,(adr_TCP_RX_VIEW_TCP_PORT_DEST_L)
	LDS temp2,(adr_TCP_RX_VIEW_TCP_PORT_DEST_H)
	LDS temp3,(adr_TCP_PORT_WEB_A_L)
	LDS temp4,(adr_TCP_PORT_WEB_A_H)
	cp temp1,temp3			; 
	brne TCP_PORT_B
	cp temp2,temp4			; 
	brne TCP_PORT_B
	jmp TCP_PORT_WEB_ABC_OK
;-------------------------------------------------------------------------------
TCP_PORT_B:
	LDS temp3,(adr_TCP_PORT_WEB_B_L)
	LDS temp4,(adr_TCP_PORT_WEB_B_H)
	cp temp1,temp3			; 
	brne TCP_PORT_C
	cp temp2,temp4			; 
	brne TCP_PORT_C
	jmp TCP_PORT_WEB_ABC_OK
;-------------------------------------------------------------------------------
TCP_PORT_C:
	LDS temp3,(adr_TCP_PORT_WEB_C_L)
	LDS temp4,(adr_TCP_PORT_WEB_C_H)
	cp temp1,temp3			; 
	brne TCP_PORT_EXTERN_ZEIT
	cp temp2,temp4			; 
	brne TCP_PORT_EXTERN_ZEIT
	jmp TCP_PORT_WEB_ABC_OK
;-------------------------------------------------------------------------------
TCP_PORT_EXTERN_ZEIT:
	LDS temp,(adr_TCP_PORT_OPEN)	
	tst temp 
	breq TCP_PORT_NO_DEFINIERT

	ldi temp3,low (TCP_PORT_ZEIT)
	ldi temp4,high(TCP_PORT_ZEIT)
	cp temp1,temp3			; 
	brne TCP_PORT_EXTERN_OFFENTLICHE_IP
	cp temp2,temp4			; 
	brne TCP_PORT_EXTERN_OFFENTLICHE_IP
	jmp TCP_RX_ZEIT
;-------------------------------------------------------------------------------
TCP_PORT_EXTERN_OFFENTLICHE_IP:
	LDS temp3,(adr_EXTERN_TCP_PORT_L)
	LDS temp4,(adr_EXTERN_TCP_PORT_H)
	cp temp1,temp3			; 
	brne TCP_PORT_NO_DEFINIERT
	cp temp2,temp4			; 
	brne TCP_PORT_NO_DEFINIERT
	jmp OFFENTLICH_IP_RX
;-------------------------------------------------------------------------------
TCP_PORT_NO_DEFINIERT:
	jmp TCP_PORT_ANGRIFF_LEICHT
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
TCP_PORT_ANGRIFF_LEICHT:
	LDS temp,(adr_FIREWALL_ON)	; Firewall aktiviert ?
	tst temp
	brne TCP_PORT_ANGRIFF_LEICHT_w
	ret
TCP_PORT_ANGRIFF_LEICHT_w:
	call FW_EINTRAG				; Eintrag	
	rjmp TCP_PORT_ANGRIFF_SAVE
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
TCP_PORT_WEB_ABC_OK:
	LDS temp,(adr_FIREWALL_ON)	; Firewall aktiviert ?	
	tst temp
	brne TCP_PORT_WEB 
	jmp TCP_WEB
;-------------------------------------------------------------------------------
; ist IP schon in der Angriffsliste ?											
TCP_PORT_WEB:
	call FW_IP_SEARCH_C	
	brcs TCP_PORT_WEB_ANGRIFF_SCHWER
	jmp TCP_WEB
;-------------------------------------------------------------------------------
; ANGRIFF_SCHWER																
TCP_PORT_WEB_ANGRIFF_SCHWER:
	call FW_EINTRAG						; Eintrag	
	call BEEP_KURZ
	LDS ZL,(adr_FW_ANGRIFFE_SCHWER_L)	; COUNTER	
	LDS ZH,(adr_FW_ANGRIFFE_SCHWER_H)
	adiw ZL,1	
	STS(adr_FW_ANGRIFFE_SCHWER_L),ZL
	STS(adr_FW_ANGRIFFE_SCHWER_H),ZH
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
TCP_PORT_ANGRIFF_SAVE:
	LDS temp,(adr_FIREWALL_BEEP_ON)	; BEEP ?	
	tst temp
	breq TCP_PORT_ANGRIFF_SAVE_w
	call BEEP_KURZ
TCP_PORT_ANGRIFF_SAVE_w:
	LDS temp,(adr_DEBUG_ANGRIFFE_ON); Debugg ?	
	tst temp
	breq TCP_PORT_ANGRIFF_SAVE_w1
	call DEBUG_ENC_RX
TCP_PORT_ANGRIFF_SAVE_w1:
	LDS temp1,(TCPdestinationPortL); Fr Anzeige
	LDS temp2,(TCPdestinationPortH)
	STS(adr_FW_PORT_DESTINATION_L),temp1
	STS(adr_FW_PORT_DESTINATION_H),temp2
	LDS temp1,(IP4SourceIPaddr3)
	LDS temp2,(IP4SourceIPaddr2)
	LDS temp3,(IP4SourceIPaddr1)
	LDS temp4,(IP4SourceIPaddr0)
	STS(adr_FW_IP4SourceIPaddr3),temp1
	STS(adr_FW_IP4SourceIPaddr2),temp2
	STS(adr_FW_IP4SourceIPaddr1),temp3
	STS(adr_FW_IP4SourceIPaddr0),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
