; ##############################################################################
; ##############################################################################
; ##############################################################################
; WCR,ECN,URG,ACK,PUSH,RESET,SYN,FIN											
TCP_WEB:
	LDS  temp1,(TCPflags)					; FLAGS laden		
	sbrs temp1,(TCPflag_SYN)				; FLAG SYN ?		
	rjmp TCP_FLAG_NO_SYN					; nein				
	jmp TCP_WEB_RX_SYN						; SYN				
TCP_FLAG_NO_SYN:
;-------------------------------------------------------------------------------
	sbrs temp1,(TCPflag_PUSH)				; FLAG PUSH	?		
	rjmp TCP_FLAG_NO_PUSH					; nein				
;-------------------------------------------------------------------------------
	call FUNCTION_SEARCH_favicon_ICO_C		; "favicon.ico" angefordert?
	brcs TCP_FLAG_PUSH_ENDE					; ja 				
	; SPEICHERN fr ANZEIGE			
	call FUNCTION_TCP_RX_DATA_LENGTH		; TCP_RX_DATA_LENGTH
;-------------------------------------------------------------------------------
	; AUFRUFE_ZAEHLER	
	LDS temp1,(adr_TCP_ANZAHL_AUFRUFE_L)
	LDS temp2,(adr_TCP_ANZAHL_AUFRUFE_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_TCP_ANZAHL_AUFRUFE_L),temp1
	STS(adr_TCP_ANZAHL_AUFRUFE_H),temp2
	call LOGBUCH_EINTRAG					; TCP_LOGBUCH Eintrag
	call TCP_PUSH							; PUSH				
	call HTML_WEBSEITE						; WEBSEITE			
	call TCP_TX_DATA						; DATA				
	call BEEP_KURZ
	call LCD_CLEAR
;-------------------------------------------------------------------------------
TCP_FLAG_PUSH_ENDE:
	ret
TCP_FLAG_NO_PUSH:
;-------------------------------------------------------------------------------
	sbrs temp1,(TCPflag_FIN)				; FLAG FIN	?		
	rjmp TCP_FLAG_NO_FIN					; nein				
	rjmp TCP_RX_FIN_ACK_TX_ACK				; FIN RESET			
TCP_FLAG_NO_FIN:
;-------------------------------------------------------------------------------
	sbrs temp1,(TCPflag_RESET)				; FLAG RESET	?	
	rjmp TCP_FLAG_NO_RESET					; nein				
	rjmp TCP_RX_FIN_ACK_TX_ACK				; FIN RESET			
TCP_FLAG_NO_RESET:
;-------------------------------------------------------------------------------
	sbrs temp1,(TCPflag_ACK)				; FLAG ACK ?		
	rjmp TCP_FLAG_NO_ACK
	ret
TCP_FLAG_NO_ACK:
;-------------------------------------------------------------------------------

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SYN-Paket wurde empfangen, SYN/ACK-Paket wird zurckgesendet					
TCP_WEB_RX_SYN:
	LED_ONLINE_ON
	; ACK=SEQ+1					
	LDS temp1,(TcpSeq0)
	LDS temp2,(TcpSeq1)
	LDS temp3,(TcpSeq2)
	LDS temp4,(TcpSeq3)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(TcpAck0),temp1
	STS(TcpAck1),temp2
	STS(TcpAck2),temp3
	STS(TcpAck3),temp4
	; SEQ=1000 (bzw. Zufallszahl)
	ldi temp1,BYTE1(1000)
	ldi temp2,BYTE2(1000)
	ldi temp3,BYTE3(1000)
	ldi temp4,BYTE4(1000)
	STS(TcpSeq0),temp1
	STS(TcpSeq1),temp2
	STS(TcpSeq2),temp3
	STS(TcpSeq3),temp4
	; OPTIONEN (Bedeutung nicht ganz klar)
	ldi temp1,0x02
	ldi temp2,0x04
	ldi temp3,0x05
	ldi temp4,0xb4
	STS(TCPdata+0),temp1
	STS(TCPdata+1),temp2
	STS(TCPdata+2),temp3
	STS(TCPdata+3),temp4
;-------------------------------------------------------------------------------
	call MAKE_MAC_NEW_HEADER					; MAC-Heder					
	call MAKE_IP4_TOTAL_LENGTH_44BYTES			; IP4-Length				
	call MAKE_IP4_TAUSCH_IP						; IP4-Heder					
	call MAKE_TCP_TAUSCH_HEADER					; TCP						
	call MAKE_TCP_HEADER_LENGTH_24BYTES			; TCP-HeaderLength			
	call MAKE_TCP_FLAG_SYN_ACK
	jmp TCP_TX_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; FIN oder Reset wurde empfangen												
TCP_RX_FIN_ACK_TX_ACK:
	LDS temp1,(TcpSeq0)	; SEQ(OLD)	
	LDS temp2,(TcpSeq1)
	LDS temp3,(TcpSeq2)
	LDS temp4,(TcpSeq3)
	LDS temp5,(TcpAck0)	; ACK(OLD)	
	LDS temp6,(TcpAck1)
	LDS temp7,(TcpAck2)
	LDS temp8,(TcpAck3)
	; ACK=SEQ+1						
	add temp1,EINS		; +1		
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(TcpAck0),temp1	; ACK		
	STS(TcpAck1),temp2
	STS(TcpAck2),temp3
	STS(TcpAck3),temp4
	; SEQ=ACK						
	STS(TcpSeq0),temp5	; SEQ		
	STS(TcpSeq1),temp6
	STS(TcpSeq2),temp7
	STS(TcpSeq3),temp8
;-------------------------------------------------------------------------------
	call MAKE_MAC_NEW_HEADER				; MAC-Heder		
	call MAKE_IP4_TOTAL_LENGTH_40BYTES		; IP4-Length	
	call MAKE_IP4_TAUSCH_IP					; IP4-Heder		
	call MAKE_TCP_TAUSCH_HEADER				; TCP			
	call MAKE_TCP_HEADER_LENGTH_20BYTES		; TCP-HeaderLength			
	call MAKE_TCP_FLAG_ACK					; TCP-ACK		
	call TCP_TX_PAKET
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	call WAIT_10ms
	call MAKE_TCP_FLAG_FIN_ACK
	call TCP_TX_PAKET
	LED_ONLINE_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Folgendes Paket wurde ev. empfangen: "GET / HTTP/1.1 Accept: */*..."			
; --> Paket wird besttigt														
TCP_PUSH:
	; SEQ ACK NR					
	call FUNCTION_TCP_RX_DATA_LENGTH		; TCP_RX_DATA_LENGTH
	LDS temp1,(TcpAck0)	; ACK(OLD)	
	LDS temp2,(TcpAck1)
	LDS temp3,(TcpAck2)
	LDS temp4,(TcpAck3)
	LDS temp5,(TcpSeq0)	; SEQ(OLD)	
	LDS temp6,(TcpSeq1)
	LDS temp7,(TcpSeq2)
	LDS temp8,(TcpSeq3)
	; SEQ=ACK(OLD)					
	STS(TcpSeq0),temp1	; SEQ		
	STS(TcpSeq1),temp2
	STS(TcpSeq2),temp3
	STS(TcpSeq3),temp4
	; ACK=SEQ(OLD)+(RX_DATA_LENGTH)
	LDS ZL,(adr_TCP_RX_DATA_LENGTH_L)
	LDS ZH,(adr_TCP_RX_DATA_LENGTH_H)
	add temp5,ZL
	adc temp6,ZH
	adc temp7,NULL
	adc temp8,NULL
	STS(TcpAck0),temp5	; ACK		
	STS(TcpAck1),temp6
	STS(TcpAck2),temp7
	STS(TcpAck3),temp8
;-------------------------------------------------------------------------------
	call MAKE_MAC_NEW_HEADER				; MAC-Heder		
	call MAKE_IP4_TOTAL_LENGTH_40BYTES		; IP4-Length	
	call MAKE_IP4_TAUSCH_IP					; IP4-Heder		
	call MAKE_TCP_TAUSCH_HEADER				; TCP			
	call MAKE_TCP_HEADER_LENGTH_20BYTES		; TCP-HeaderLength			
	call MAKE_TCP_FLAG_ACK					; TCP-FLAG-ACK				
	jmp TCP_TX_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################

