; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp (Fehler-Code)														
ERROR_SAVE_TEMP:
	CLI											; INTERRUPTS sperren	
	STS adr_ERROR_CODE,temp						; ERROR-CODE			
	LDS temp,(adr_MODUL_NR)						; MODUL-NR				
	STS(adr_ERROR_MODUL_NR),temp

	call ANZEIGE_ERROR
;-------------------------------------------------------------------------------
	ldi temp9,20
ERROR_SAVE_TEMP_s:
	BEEP_ON
	call wait_100ms
	BEEP_OFF
	call wait_100ms
	dec temp9
	brne ERROR_SAVE_TEMP_s
	call EEPROM_SAVE				; SAVE		
	call WAIT_1s
	jmp PROGRAMM_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp (WARNUNGS-Code)														
WARNUNG_SAVE_TEMP:
	LED_ROT_ON
	STS(adr_WARNUNG_CODE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; WDTCSR  Watchdog Timer Control Register										
; WDIF WDIE WDP3 WDCE WDE WDP2 WDP1 WDP0										
; WDP3 WDP2 WDP1 WDP0 Time														
;	0 	0 	0 	0 	2K 	(2048) 	cycles 16 ms									
;	0 	0 	0 	1 	4K 	(4096) 	cycles 32 ms									
;	0 	0 	1 	0 	8K 	(8192) 	cycles 64 ms									
;	0 	0 	1 	1 	16K (16384) cycles 0.125 s									
;	0 	1 	0 	0 	32K (32768) cycles 0.25 s									
; 	0 	1 	0 	1 	64K (65536) cycles 0.5 s									
; *	0 	1 	1 	0 	128K (131072)cycles 1.0 s									
;	0 	1 	1 	1 	256K (262144)cycles 2.0 s									
;	1 	0 	0 	0 	512K (524288)cycles 4.0 s									
;	1 	0 	0 	1 	1024K(1048576)cycles 8.0 s									
; Wenn WDIE=1 dann wird zuerst die WDR-ISR aufgerufen 							
; und dann das System neu gestartet												
WDR_INITIALISIERUNG:
	WDR
	LDS TEMP, WDTCSR
	ori TEMP, (1<<WDCE) | (1<<WDE)
	STS WDTCSR, TEMP
	ldi temp, (1<<WDE)| (1<<WDIE)|(0<<WDP3)|(1<<WDP2)|(1<<WDP1)|(0<<WDP0)
	STS WDTCSR, TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MCUSR  MCU Status Register													
; 7,6,5,JTRF,WDRF,BORF,EXTRF,PORF												
; NEUSTART ber WDR, wenn BORF,EXTRF,PORF gestzt ist							
NEUSTART_MIT_WDR:
	in temp, MCUSR
	andi temp,0b00000111
	tst temp
	brne NEUSTART_MIT_WDR_FEHLER
	ret
NEUSTART_MIT_WDR_FEHLER:
	out MCUSR,NULL
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_RESET:
	CLI											; INTERRUPTS sperren	
	LED_ARP_ON
	LED_OW_ON
	LED_ENC_ON
	LED_ONLINE_ON
	LED_ROT_ON
	BEEP_ON
	call ZEILE4
	call TEXT_RESET
;-------------------------------------------------------------------------------
PROGRAMM_RESET_s:
	rjmp PROGRAMM_RESET_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; Version			
	ldi temp,(VERSION)
	STS(adr_VERSION),temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	STS(adr_SRAM_CHECK_A),temp
	STS(adr_SRAM_CHECK_B),temp
	STS(adr_SRAM_CHECK_C),temp
	STS(adr_SRAM_CHECK_D),temp
	; ZEIT_DATUM		
	STS(adr_TAG),EINS
	STS(adr_MONAT),EINS
	STS(adr_JAHR) ,NULL
	STS(adr_WOCHENTAG),EINS
	ldi temp,0
	STS(adr_hh),temp
	ldi temp,0
	STS(adr_mm),temp
	ldi temp,55
	STS(adr_ss),temp
	; MAC				
	ldi temp1,(MACeigene0)
	ldi temp2,(MACeigene1)
	ldi temp3,(MACeigene2)
	ldi temp4,(MACeigene3)
	ldi temp5,(MACeigene4)
	ldi temp6,(MACeigene5)
	STS(adr_MAC0),temp1
	STS(adr_MAC1),temp2
	STS(adr_MAC2),temp3
	STS(adr_MAC3),temp4
	STS(adr_MAC4),temp5
	STS(adr_MAC5),temp6
	; IP-Adresse eigene	
	ldi temp1,IPeigene0
	ldi temp2,IPeigene1
	ldi temp3,IPeigene2
	ldi temp4,IPeigene3
	STS(adr_IP_EIGENE0),temp1
	STS(adr_IP_EIGENE1),temp2
	STS(adr_IP_EIGENE2),temp3
	STS(adr_IP_EIGENE3),temp4
	; IP-Adresse ROUTER
	ldi temp1,IProuter0
	ldi temp2,IProuter1
	ldi temp3,IProuter2
	ldi temp4,IProuter3
	STS(adr_IP_ROUTER0),temp1
	STS(adr_IP_ROUTER1),temp2
	STS(adr_IP_ROUTER2),temp3
	STS(adr_IP_ROUTER3),temp4
	; Ports fr Webseiten	
	ldi temp1,LOW (TCP_PORT_WEB_A)
	ldi temp2,HIGH(TCP_PORT_WEB_A)
	STS(adr_TCP_PORT_WEB_A_L),temp1
	STS(adr_TCP_PORT_WEB_A_H),temp2
	ldi temp1,LOW (TCP_PORT_WEB_B)
	ldi temp2,HIGH(TCP_PORT_WEB_B)
	STS(adr_TCP_PORT_WEB_B_L),temp1
	STS(adr_TCP_PORT_WEB_B_H),temp2
	ldi temp1,LOW (TCP_PORT_WEB_C)
	ldi temp2,HIGH(TCP_PORT_WEB_C)
	STS(adr_TCP_PORT_WEB_C_L),temp1
	STS(adr_TCP_PORT_WEB_C_H),temp2
	; diverses				
	STS(adr_ARP_SCAN_ON),EINS
	STS(adr_FIREWALL_ON),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-4)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-4)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZUFALLSZAHL_TEMP1:
	push ZL
	push ZH
	ldi ZL,LOW (SRAM_START)
	ldi ZH,HIGH(SRAM_START)
ZUFALLSZAHL_s:
	LD R0,Z+
	add temp1,R0
	eor temp1,R0
	cpi ZL, LOW(adr_SRAM_CHECK_D)
	brne ZUFALLSZAHL_s
	cpi ZH,high(adr_SRAM_CHECK_D)
	brne ZUFALLSZAHL_s
	pop ZH
	pop ZL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT A+B+C+D CLEAR															
PORT_CLEAR:
	clr temp
	out DDRA, temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTA,temp
	out PORTB,temp
	out PORTC,temp
	out PORTD,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
	clr R16
	clr R17
	clr R18
	clr R19
	clr R20
	clr R21
	clr R22
	clr R23
	clr R24
	clr R25
	clr R26
	clr R27
	clr R28
	clr R29
	clr R30
	clr R31
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_FRONT0_DDR),(LED_FRONT0_PIN_NR)		; GRN		
	sbi (LED_FRONT1_DDR),(LED_FRONT1_PIN_NR)		; GRN2		
	sbi (LED_FRONT2_DDR),(LED_FRONT2_PIN_NR)		; GELB		
	sbi (LED_FRONT3_DDR),(LED_FRONT3_PIN_NR)		; ROT		
	sbi (LED_FRONT4_DDR),(LED_FRONT4_PIN_NR)		; ORANGE	
	sbi (LED_A_DDR) 	,(LED_A_PIN_NR)				; A			
	sbi (LED_B_DDR) 	,(LED_B_PIN_NR)				; B			
	sbi (LED_C_DDR) 	,(LED_C_PIN_NR)				; C			
	sbi (BEEP_DDR)      ,(BEEP_PIN_NR)				; BEEP		
	sbi (BEEP_PORT)		,(BEEP_PIN_NR)				; BEEP aus	
	sbi (RESET_ENC_DDR) ,(RESET_ENC_PIN_NR)			; RESET		
	sbi (RESET_ENC_PORT),(RESET_ENC_PIN_NR)			; RESET high
	; LED aus									
	LED_ARP_OFF
	LED_OW_OFF
	LED_ENC_OFF
	LED_ONLINE_OFF
	LED_ROT_OFF
	LED_A_OFF
	LED_B_OFF
	LED_C_OFF
	; LED an									
	LED_ARP_ON
	call wait_100ms
	LED_OW_ON
	call wait_100ms
	LED_ENC_ON
	call wait_100ms
	LED_ONLINE_ON
	call wait_100ms
	LED_ROT_ON
	call wait_100ms
	LED_A_ON
	call wait_100ms
	LED_B_ON
	call wait_100ms
	LED_C_ON
	call wait_100ms
	; LED aus									
	LED_ARP_OFF
	LED_OW_OFF
	LED_ENC_OFF
	LED_ONLINE_OFF
	LED_ROT_OFF
	LED_A_OFF
	LED_B_OFF
	LED_C_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KURZ:
	BEEP_ON
	call WAIT_10ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_2X:
	BEEP_ON
	call WAIT_10ms
	BEEP_OFF
	call WAIT_100ms
	BEEP_ON
	call WAIT_10ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_3X:
	BEEP_ON
	call WAIT_100ms
	BEEP_OFF
	call WAIT_100ms
	BEEP_ON
	call WAIT_100ms
	BEEP_OFF
	call WAIT_100ms
	BEEP_ON
	call WAIT_100ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP:
	BEEP_ON
	call WAIT_100ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_LANG:
	BEEP_ON
	call WAIT_1s
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR_0
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR_1
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR_255
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK_D)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_D
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_S
	LDS temp,(adr_SRAM_CHECK_A)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_A
	LDS temp,(adr_SRAM_CHECK_B)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_B
	LDS temp,(adr_SRAM_CHECK_C)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_C
	LDS temp,(adr_SRAM_CHECK_D)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR_D
ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR_0:
	ldi temp,(ERROR_PROGRAMM_CHECK_0)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_1:
	ldi temp,(ERROR_PROGRAMM_CHECK_1)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_255:
	ldi temp,(ERROR_PROGRAMM_CHECK_255)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_S:
	ldi temp,(ERROR_PROGRAMM_CHECK_S)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_A:
	ldi temp,(ERROR_PROGRAMM_CHECK_A)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_B:
	ldi temp,(ERROR_PROGRAMM_CHECK_B)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_C:
	ldi temp,(ERROR_PROGRAMM_CHECK_C)
	jmp ERROR_SAVE_TEMP
PROGRAMM_CHECK_ERROR_D:
	ldi temp,(ERROR_PROGRAMM_CHECK_D)
	jmp ERROR_SAVE_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMPERATUR_MIN_MAX_INITIALISIERUNG:
	LDS temp1,(adr_TEMPERATUR_MAX_L)
	LDS temp2,(adr_TEMPERATUR_MAX_H)
	tst temp1
	brne TEMPERATUR_MIN_INITIALISIERUNG
	tst temp2
	brne TEMPERATUR_MIN_INITIALISIERUNG
	; Temperatur-MAX		
	ldi temp1,LOW (-999)
	ldi temp2,HIGH(-999)
	STS(adr_TEMPERATUR_MAX_L),temp1
	STS(adr_TEMPERATUR_MAX_H),temp2
TEMPERATUR_MIN_INITIALISIERUNG:
	LDS temp1,(adr_TEMPERATUR_MIN_L)
	LDS temp2,(adr_TEMPERATUR_MIN_H)
	tst temp1
	brne TEMPERATUR_MIN_MAX_INITIALISIERUNG_FERTIG
	tst temp2
	brne TEMPERATUR_MIN_MAX_INITIALISIERUNG_FERTIG
	; Temperatur-MIN		
	ldi temp1,LOW (999)
	ldi temp2,HIGH(999)
	STS(adr_TEMPERATUR_MIN_L),temp1
	STS(adr_TEMPERATUR_MIN_H),temp2
TEMPERATUR_MIN_MAX_INITIALISIERUNG_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; -32.768...............32.767													
; (10000000-00000000)...(01111111-11111111)										
;																				
TEMPERATUR_MAX:
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	tst temp1
	brne TEMPERATUR_MAX_RUN	; 0 Grad ignorieren	
	tst temp2
	brne TEMPERATUR_MAX_RUN
	ret
;-------------------------------------------------------------------------------
TEMPERATUR_MAX_RUN:
	ldi ZL,LOW (1000)	; 100C		
	ldi ZH,HIGH(1000)
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	add temp1,ZL		; +100C	
	adc temp2,ZH

	LDS temp3,(adr_TEMPERATUR_MAX_L)
	LDS temp4,(adr_TEMPERATUR_MAX_H)
	add temp3,ZL		; +100C	
	adc temp4,ZH

	cp temp2,temp4
	breq TEMPERATUR_MAX_w
	brsh TEMPERATUR_MAX_AKTION
	ret

TEMPERATUR_MAX_w:
	cp temp1,temp3
	brsh TEMPERATUR_MAX_AKTION
	ret
;-------------------------------------------------------------------------------
TEMPERATUR_MAX_AKTION:
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	STS(adr_TEMPERATUR_MAX_L),temp1
	STS(adr_TEMPERATUR_MAX_H),temp2

	LDS temp1,(adr_mm)			; Zeitstempel	
	LDS temp2,(adr_hh)
	STS(adr_TEMPERATUR_MAX_mm),temp1
	STS(adr_TEMPERATUR_MAX_hh),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMPERATUR_MIN:
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	tst temp1
	brne TEMPERATUR_MIN_RUN	; 0 Grad ignorieren	
	tst temp2
	brne TEMPERATUR_MIN_RUN
	ret
;-------------------------------------------------------------------------------
TEMPERATUR_MIN_RUN:
	ldi ZL,LOW (1000)	; 100C		
	ldi ZH,HIGH(1000)
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	add temp1,ZL		; +100C	
	adc temp2,ZH

	LDS temp3,(adr_TEMPERATUR_MIN_L)
	LDS temp4,(adr_TEMPERATUR_MIN_H)
	add temp3,ZL		; +100C	
	adc temp4,ZH

	cp temp2,temp4
	breq TEMPERATUR_MIN_w
	brlo TEMPERATUR_MIN_AKTION
	ret
TEMPERATUR_MIN_w:
	cp temp1,temp3
	brlo TEMPERATUR_MIN_AKTION
	ret
;-------------------------------------------------------------------------------
TEMPERATUR_MIN_AKTION:
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	STS(adr_TEMPERATUR_MIN_L),temp1
	STS(adr_TEMPERATUR_MIN_H),temp2

	LDS temp1,(adr_mm)			; Zeitstempel	
	LDS temp2,(adr_hh)
	STS(adr_TEMPERATUR_MIN_mm),temp1
	STS(adr_TEMPERATUR_MIN_hh),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMPERATURSTATISTIK_STUNDE:
	LDS temp1,(adr_TEMPERATUR_AUSSEN_L)
	LDS temp2,(adr_TEMPERATUR_AUSSEN_H)
	LDS temp,(adr_hh)	
	cpi temp,0
	breq TEMPERATURSTATISTIK_00
	cpi temp,6
	breq TEMPERATURSTATISTIK_06
	cpi temp,12
	breq TEMPERATURSTATISTIK_12
	cpi temp,18
	breq TEMPERATURSTATISTIK_18
	ret
;-------------------------------------------------------------------------------
TEMPERATURSTATISTIK_00:
	STS(adr_TEMPERATUR_00_UHR_L),temp1
	STS(adr_TEMPERATUR_00_UHR_H),temp2
	ret
TEMPERATURSTATISTIK_06:
	STS(adr_TEMPERATUR_06_UHR_L),temp1
	STS(adr_TEMPERATUR_06_UHR_H),temp2
	ret
TEMPERATURSTATISTIK_12:
	STS(adr_TEMPERATUR_12_UHR_L),temp1
	STS(adr_TEMPERATUR_12_UHR_H),temp2
	ret
TEMPERATURSTATISTIK_18:
	STS(adr_TEMPERATUR_18_UHR_L),temp1
	STS(adr_TEMPERATUR_18_UHR_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMPERATURSTATISTIK_TAG:
	; Temperatur-MAX						
	LDS temp1,(adr_TEMPERATUR_MAX_L)
	LDS temp2,(adr_TEMPERATUR_MAX_H)
	STS(adr_TEMPERATUR_GESTERN_MAX_L),temp1
	STS(adr_TEMPERATUR_GESTERN_MAX_H),temp2
	ldi temp1,LOW (-999); -99,9C
	ldi temp2,HIGH(-999)
	STS(adr_TEMPERATUR_MAX_L),temp1
	STS(adr_TEMPERATUR_MAX_H),temp2
	; Temperatur-MIN						
	LDS temp1,(adr_TEMPERATUR_MIN_L)
	LDS temp2,(adr_TEMPERATUR_MIN_H)
	STS(adr_TEMPERATUR_GESTERN_MIN_L),temp1
	STS(adr_TEMPERATUR_GESTERN_MIN_H),temp2
	ldi temp1,LOW (999); +99,9C
	ldi temp2,HIGH(999)
	STS(adr_TEMPERATUR_MIN_L),temp1
	STS(adr_TEMPERATUR_MIN_H),temp2
	; Zeitstempel-MAX						
	LDS temp1,(adr_TEMPERATUR_MAX_mm)
	LDS temp2,(adr_TEMPERATUR_MAX_hh)
	STS(adr_TEMPERATUR_GESTERN_MAX_mm),temp1
	STS(adr_TEMPERATUR_GESTERN_MAX_hh),temp2
	; Zeitstempel-MIN						
	LDS temp1,(adr_TEMPERATUR_MIN_mm)
	LDS temp2,(adr_TEMPERATUR_MIN_hh)
	STS(adr_TEMPERATUR_GESTERN_MIN_mm),temp1
	STS(adr_TEMPERATUR_GESTERN_MIN_hh),temp2
	; Temperaturen 0+6+12+18 Uhr			
	LDS temp1,(adr_TEMPERATUR_00_UHR_L)
	LDS temp2,(adr_TEMPERATUR_00_UHR_H)
	STS(adr_TEMPERATUR_GESTERN_00_UHR_L),temp1
	STS(adr_TEMPERATUR_GESTERN_00_UHR_H),temp2
	LDS temp1,(adr_TEMPERATUR_06_UHR_L)
	LDS temp2,(adr_TEMPERATUR_06_UHR_H)
	STS(adr_TEMPERATUR_GESTERN_06_UHR_L),temp1
	STS(adr_TEMPERATUR_GESTERN_06_UHR_H),temp2
	LDS temp1,(adr_TEMPERATUR_12_UHR_L)
	LDS temp2,(adr_TEMPERATUR_12_UHR_H)
	STS(adr_TEMPERATUR_GESTERN_12_UHR_L),temp1
	STS(adr_TEMPERATUR_GESTERN_12_UHR_H),temp2
	LDS temp1,(adr_TEMPERATUR_18_UHR_L)
	LDS temp2,(adr_TEMPERATUR_18_UHR_H)
	STS(adr_TEMPERATUR_GESTERN_18_UHR_L),temp1
	STS(adr_TEMPERATUR_GESTERN_18_UHR_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
