; ENC28J60																
; ATmega1284P-16MHz 													
; LCD 4x16																
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 11/2019														
;																		
; verschachtelte Interrupts												

;																		
; GRN leuchtet: alles-ok und alles schn								
; GRN leuchtet: 1wire Data (nach 1min aus)								
; GELB leuchtet: ENC RX/TX												
; ROT  leuchtet: Error 1wire											
;																		

;																		
; Blinken die LEDs, das ist nicht gut !									
;																		
; ROT+GRN blinkt: 			CLKRDY nicht erkannt (ev. Harwarefehler ?)	
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		
.include "m1284pdef.inc"								; ATmega1284P 	
.include "MACROS.asm"									; Macros		
.equ VERSION								= 2			; Version		
.equ TAKT									= 16000000	; 16 MHz		
.equ BAUD									= 9600
.equ ZEIT_LED_1WIRE							= 65
.equ ZEIT_PORT_TCP							= 120	
.equ ZEIT_PORT_UDP							= 10
.equ ZEIT_PORT_CLOSE						= 2	
; TCP_PORTs												
.equ TCP_PORT_WEB_A							= 90
.equ TCP_PORT_WEB_B							= 91
.equ TCP_PORT_WEB_C							= 92
; MAC-Adresse MAC 00:22:F9:XX:XX:XX						
.equ MACeigene0								= 0x00		; nicht ndern (herstellerspezifisch) !	 	
.equ MACeigene1								= 0x22		; nicht ndern (herstellerspezifisch) !	 	
.equ MACeigene2								= 0xF9		; nicht ndern (herstellerspezifisch) !	 	
.equ MACeigene3								= 0x00		;00 0x01 		; 0xFF
.equ MACeigene4								= 0x00		;00 0xBD 		; 0xFF 
.equ MACeigene5								= 0x01		;01 0x73 		; 0xFF 
; IP-ADRESSE eigene privat (192.168.0.90)			
.equ IPeigene0								= 192
.equ IPeigene1								= 168
.equ IPeigene2								= 0
.equ IPeigene3								= 90		; 90
; IP-ADRESSE ROUTER privat (192.168.0.1)			
.equ IProuter0								= 192
.equ IProuter1								= 168
.equ IProuter2								= 0
.equ IProuter3								= 1 
; ERROR-CODES											
.equ ERROR_DUMMY							= 0xFF		; DUMMY					
.equ ERROR_ENC_BFS							= 0x01		; Bit Field Set			
.equ ERROR_ENC_BFC							= 0x02		; Bit Field Clear		
.equ ERROR_ENC_RCR							= 0x03		; Read Control Register	
.equ ERROR_ENC_WCR							= 0x04		; Write Control Register
.equ ERROR_ENC_RBM							= 0x05		; Read Buffer Memory	
.equ ERROR_ENC_WBM							= 0x06		; Write Buffer Memory	
.equ ERROR_ENC_READ_PHY_REGISTER			= 0x07		; READ_PHY_REGISTER		
.equ ERROR_ENC_WRITE_PHY_REGISTER			= 0x08		; WRITE_PHY_REGISTER	
.equ ERROR_CONTROL_REGISTER_CHECK			= 0x0A		; CONTROL-REGISTER-CHECK
.equ ERROR_ENC_MAC_ADR						= 0x0B		; MAC-Adresse			
.equ ERROR_ENC_RX_NULL_FRAMELEN				= 0x10		; TX_MAX_FRAMELEN		
.equ ERROR_ENC_RX_MAX_FRAMELEN				= 0x11		; TX_MAX_FRAMELEN		
.equ ERROR_ENC_TX_MAX_FRAMELEN				= 0x12		; TX_MAX_FRAMELEN		
.equ ERROR_HTML_CONTENENT_LENGTH			= 0x13		; HTML CONTENENT_LENGTH	
.equ ERROR_INTERRUPT						= 0x21
.equ ERROR_WDR								= 0x22
.equ ERROR_PROGRAMM_CHECK_0					= 0xE0
.equ ERROR_PROGRAMM_CHECK_1					= 0xE1
.equ ERROR_PROGRAMM_CHECK_255				= 0xEF
.equ ERROR_PROGRAMM_CHECK_A					= 0xEA
.equ ERROR_PROGRAMM_CHECK_B					= 0xEB
.equ ERROR_PROGRAMM_CHECK_C					= 0xEC
.equ ERROR_PROGRAMM_CHECK_D					= 0xED
.equ ERROR_PROGRAMM_CHECK_S					= 0xEE
; Warnung Code										
.equ ERROR_TCP_CRC							= 0xA1
.equ ERROR_ENC_TX							= 0xA2
.equ ERROR_IP								= 0xA4
; MODUL-NR												
.equ MODUL_RX								= 0x10
.equ MODUL_RX_ARP							= 0x12
.equ MODUL_RX_ICMP							= 0x13
.equ MODUL_RX_TCP							= 0x16
.equ MODUL_RX_UDP							= 0x18
.equ MODUL_TX								= 0x40
.equ MODUL_HTML								= 0x50
.equ MODUL_TASTEN							= 0x60
; 1-WIRE											
.equ OWIRE_PIN_NR							= 3		; PA3=PCINT3
.equ OWIRE_DDR								= DDRA
.equ OWIRE_PORT								= PORTA
.equ OWIRE_PIN								= PINA
.equ OW_COMMAND_SKIP_ROM					= 0xCC	; 1-WIRE-ROM-COMMANDS		
.equ OW_FUNCTION_WRITE_PRIVATE_DATA			= 0xF6	; 1-WIRE-FUNCTION-COMMANDS	
; TASTE "MENUE-PLUS"	PA0							
.equ TASTE_MENUE_PLUS_PIN_NR				= 0
.equ TASTE_MENUE_PLUS_PIN					= PINA
.equ TASTE_MENUE_PLUS_DDR					= DDRA
.equ TASTE_MENUE_PLUS_PORT					= PORTA
; TASTE "MENUE-MINUS" 	PC7							
.equ TASTE_MENUE_MINUS_PIN_NR				= 7
.equ TASTE_MENUE_MINUS_PIN					= PINC
.equ TASTE_MENUE_MINUS_DDR					= DDRC
.equ TASTE_MENUE_MINUS_PORT					= PORTC
; TASTE "PLUS"										
.equ TASTE_PLUS_PIN_NR						= 1
.equ TASTE_PLUS_PIN							= PINA
.equ TASTE_PLUS_DDR							= DDRA
.equ TASTE_PLUS_PORT						= PORTA
; TASTE "MINUS"										
.equ TASTE_MINUS_PIN_NR						= 2
.equ TASTE_MINUS_PIN						= PINA
.equ TASTE_MINUS_DDR						= DDRA
.equ TASTE_MINUS_PORT						= PORTA
; LED-ARP (GRUEN)									
.equ LED_FRONT0_PIN_NR						= 2
.equ LED_FRONT0_DDR							= DDRC
.equ LED_FRONT0_PORT						= PORTC
; LED-1WIRE(GRUEN)									
.equ LED_FRONT1_PIN_NR						= 3
.equ LED_FRONT1_PIN							= PINC
.equ LED_FRONT1_DDR							= DDRC
.equ LED_FRONT1_PORT						= PORTC
; LED-ENC-RX(GELB)									
.equ LED_FRONT2_PIN_NR						= 4
.equ LED_FRONT2_DDR							= DDRC
.equ LED_FRONT2_PORT						= PORTC
; LED-ENC-TX(ROT)									
.equ LED_FRONT3_PIN_NR						= 5
.equ LED_FRONT3_DDR							= DDRC
.equ LED_FRONT3_PORT						= PORTC
; LED-ORANGE										
.equ LED_FRONT4_PIN_NR						= 6
.equ LED_FRONT4_DDR							= DDRC
.equ LED_FRONT4_PORT						= PORTC
; BEEP												
.equ BEEP_PIN_NR							= 3
.equ BEEP_DDR								= DDRD
.equ BEEP_PORT								= PORTD	
; HARDWARE-RESET ENC								
.equ RESET_ENC_PIN_NR						= 4
.equ RESET_ENC_DDR							= DDRA
.equ RESET_ENC_PORT							= PORTA
; LED-RESERVE-A										
.equ LED_A_PIN_NR							= 5
.equ LED_A_DDR								= DDRA
.equ LED_A_PORT								= PORTA
; LED-RESERVE-B										
.equ LED_B_PIN_NR							= 6
.equ LED_B_DDR								= DDRA
.equ LED_B_PORT								= PORTA
; LED-RESERVE-C										
.equ LED_C_PIN_NR							= 7
.equ LED_C_DDR								= DDRA
.equ LED_C_PORT								= PORTA
; LCD (DATA)										
.equ LCD_DATA0_DDR							= DDRD
.equ LCD_DATA1_DDR							= DDRD
.equ LCD_DATA2_DDR							= DDRD
.equ LCD_DATA3_DDR							= DDRD
.equ LCD_DATA0_PORT							= PORTD
.equ LCD_DATA1_PORT							= PORTD
.equ LCD_DATA2_PORT							= PORTD
.equ LCD_DATA3_PORT							= PORTD
.equ LCD_DATA0								= 7
.equ LCD_DATA1								= 6
.equ LCD_DATA2								= 5
.equ LCD_DATA3								= 4
; LCD RS (Befehl/DATEN)								
.equ LCD_RS_DDR								= DDRB
.equ LCD_RS_PORT							= PORTB
.equ LCD_RS									= 3
; LCD_ENABLE										
.equ LCD_EN_DDR								= DDRB
.equ LCD_EN_PORT							= PORTB
.equ LCD_EN									= 0
; REGISTER											
.def ERROR			= R11
.def DUMMY			= R12
.def NULL 			= R13
.def EINS 			= R14
.def VOLL			= R15
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; EEPROM-BELEGUNG										
.equ adr_EEPROM_SYSTEM_DATA				=0 		; SYSTEM_DATA	
.equ adr_EEPROM_FW_DATA					=200	; Firewall DATA 


; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_VERSION						=SRAM_START+0		; VERSION					

.equ adr_ANZAHL_START_L					=SRAM_START+2		; Anzahl Programm-Starts	
.equ adr_ANZAHL_START_H					=SRAM_START+3
.equ adr_TCP_PORT_WEB_A_L				=SRAM_START+4		; PORT-WEBSEITE-A			
.equ adr_TCP_PORT_WEB_A_H				=SRAM_START+5
.equ adr_TCP_PORT_WEB_B_L				=SRAM_START+6		; PORT-WEBSEITE-B			
.equ adr_TCP_PORT_WEB_B_H				=SRAM_START+7
.equ adr_TCP_PORT_WEB_C_L				=SRAM_START+8		; PORT-WEBSEITE-C			
.equ adr_TCP_PORT_WEB_C_H				=SRAM_START+9

.equ adr_ARP_SCAN_ON					=SRAM_START+10		; ARP-TX-REQUEST aktiv		
.equ adr_FIREWALL_ON					=SRAM_START+11		; 
.equ adr_FIREWALL_BEEP_ON				=SRAM_START+12		; 
.equ adr_DEBUG_RX_ON					=SRAM_START+13		; USART-DEBUG-RX			
.equ adr_DEBUG_TX_ON					=SRAM_START+14		; USART-DEBUG-TX			
.equ adr_DEBUG_ANGRIFFE_ON				=SRAM_START+15		; USART-DEBUG-Angriffe		
.equ adr_DEBUG_RX_UDP_ON				=SRAM_START+16		;

.equ adr_ERROR_MODUL_NR					=SRAM_START+30		; Modul-Nr  (fr Fehlersuche)	
.equ adr_ERROR_CODE						=SRAM_START+31		; ERROR-CODE(fr Fehlersuche)	
.equ adr_WARNUNG_CODE					=SRAM_START+32

.equ adr_MAC0							=SRAM_START+100		; MAC						
.equ adr_MAC1							=SRAM_START+101
.equ adr_MAC2							=SRAM_START+102
.equ adr_MAC3							=SRAM_START+103
.equ adr_MAC4							=SRAM_START+104
.equ adr_MAC5							=SRAM_START+105

.equ adr_IP_EIGENE0						=SRAM_START+112		; IP eigene					
.equ adr_IP_EIGENE1						=SRAM_START+113
.equ adr_IP_EIGENE2						=SRAM_START+114
.equ adr_IP_EIGENE3						=SRAM_START+115

.equ adr_IP_ROUTER0						=SRAM_START+116		; IP ROUTER					
.equ adr_IP_ROUTER1						=SRAM_START+117
.equ adr_IP_ROUTER2						=SRAM_START+118
.equ adr_IP_ROUTER3						=SRAM_START+119

.equ adr_TEMPERATUR_00_UHR_L			=SRAM_START+120		; Aussentemperatur (heute)	
.equ adr_TEMPERATUR_00_UHR_H			=SRAM_START+121
.equ adr_TEMPERATUR_06_UHR_L			=SRAM_START+122
.equ adr_TEMPERATUR_06_UHR_H			=SRAM_START+123
.equ adr_TEMPERATUR_12_UHR_L			=SRAM_START+124
.equ adr_TEMPERATUR_12_UHR_H			=SRAM_START+125
.equ adr_TEMPERATUR_18_UHR_L			=SRAM_START+126
.equ adr_TEMPERATUR_18_UHR_H			=SRAM_START+127

.equ adr_TEMPERATUR_GESTERN_00_UHR_L	=SRAM_START+130		; Aussentemperatur (gestern)
.equ adr_TEMPERATUR_GESTERN_00_UHR_H	=SRAM_START+131
.equ adr_TEMPERATUR_GESTERN_06_UHR_L	=SRAM_START+132
.equ adr_TEMPERATUR_GESTERN_06_UHR_H	=SRAM_START+133
.equ adr_TEMPERATUR_GESTERN_12_UHR_L	=SRAM_START+134
.equ adr_TEMPERATUR_GESTERN_12_UHR_H	=SRAM_START+135
.equ adr_TEMPERATUR_GESTERN_18_UHR_L	=SRAM_START+136
.equ adr_TEMPERATUR_GESTERN_18_UHR_H	=SRAM_START+137

.equ adr_TEMPERATUR_MAX_L				=SRAM_START+140
.equ adr_TEMPERATUR_MAX_H				=SRAM_START+141
.equ adr_TEMPERATUR_MIN_L				=SRAM_START+142
.equ adr_TEMPERATUR_MIN_H				=SRAM_START+143

.equ adr_TEMPERATUR_GESTERN_MAX_L		=SRAM_START+144
.equ adr_TEMPERATUR_GESTERN_MAX_H		=SRAM_START+145
.equ adr_TEMPERATUR_GESTERN_MIN_L		=SRAM_START+146
.equ adr_TEMPERATUR_GESTERN_MIN_H		=SRAM_START+147

.equ adr_TEMPERATUR_MAX_mm				=SRAM_START+150
.equ adr_TEMPERATUR_MAX_hh				=SRAM_START+151
.equ adr_TEMPERATUR_MIN_mm				=SRAM_START+152
.equ adr_TEMPERATUR_MIN_hh				=SRAM_START+153

.equ adr_TEMPERATUR_GESTERN_MAX_mm		=SRAM_START+154
.equ adr_TEMPERATUR_GESTERN_MAX_hh		=SRAM_START+155
.equ adr_TEMPERATUR_GESTERN_MIN_mm		=SRAM_START+156
.equ adr_TEMPERATUR_GESTERN_MIN_hh		=SRAM_START+157

.equ adr_SRAM_CHECK_A					=SRAM_START+200	; SRAM CHECK muss immer "S" sein	
.equ adr_ENC_RX_PAKET_COUNTER_ALLE_L	=SRAM_START+202	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_ALLE_H	=SRAM_START+203
.equ adr_ENC_RX_PAKET_COUNTER_IPv6_L	=SRAM_START+204	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_IPv6_H	=SRAM_START+205
.equ adr_ENC_RX_PAKET_COUNTER_NO_IPV4_L	=SRAM_START+206	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_NO_IPV4_H	=SRAM_START+207
.equ adr_ENC_RX_PAKET_COUNTER_ARP_L		=SRAM_START+208	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_ARP_H		=SRAM_START+209
.equ adr_ENC_RX_PAKET_COUNTER_ICMP_L	=SRAM_START+210	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_ICMP_H	=SRAM_START+211
.equ adr_ENC_RX_PAKET_COUNTER_TCP_L		=SRAM_START+212	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_TCP_H		=SRAM_START+213
.equ adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_L=SRAM_START+214	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_TCP_CRC_ERROR_H=SRAM_START+215
.equ adr_ENC_RX_PAKET_COUNTER_UDP_L		=SRAM_START+216	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_UDP_H		=SRAM_START+217
.equ adr_ENC_RX_PAKET_COUNTER_SONST_L	=SRAM_START+218	; Counter				
.equ adr_ENC_RX_PAKET_COUNTER_SONST_H	=SRAM_START+219
.equ adr_ENC_RX_NEXT_READ_POINTER_L		=SRAM_START+220 	; Next Read Pointer(L) 
.equ adr_ENC_RX_NEXT_READ_POINTER_H		=SRAM_START+221 	; Next Read Pointer(H) 
.equ adr_ENC_RX_FRAME_LENGTH_L			=SRAM_START+222
.equ adr_ENC_RX_FRAME_LENGTH_H			=SRAM_START+223
.equ adr_ENC_TX_PAKET_COUNTER_L			=SRAM_START+225
.equ adr_ENC_TX_PAKET_COUNTER_H			=SRAM_START+226
.equ adr_ENC_TX_PAKET_COUNTER_ERROR_L	=SRAM_START+227
.equ adr_ENC_TX_PAKET_COUNTER_ERROR_H	=SRAM_START+228
.equ adr_ENC_TX_FRAME_LENGTH_L			=SRAM_START+229
.equ adr_ENC_TX_FRAME_LENGTH_H			=SRAM_START+230
.equ adr_ENC_TX_STATUS_VECTOR_0			=SRAM_START+231
.equ adr_ENC_TX_STATUS_VECTOR_1			=SRAM_START+232
.equ adr_ENC_TX_STATUS_VECTOR_2			=SRAM_START+233
.equ adr_ENC_TX_STATUS_VECTOR_3			=SRAM_START+234
.equ adr_ENC_TX_STATUS_VECTOR_4			=SRAM_START+235
.equ adr_ENC_TX_STATUS_VECTOR_5			=SRAM_START+236
.equ adr_ENC_TX_STATUS_VECTOR_6			=SRAM_START+237



.equ adr_MENUE							=SRAM_START+300	; Menue						
.equ adr_TASTE							=SRAM_START+301	; Tasten					
.equ adr_MODUL_NR						=SRAM_START+302
.equ adr_ARP_SCAN_NR					=SRAM_START+303	; IP-SCAN (ARP)				
.equ adr_ARP_CHACHE_ANZAHL				=SRAM_START+304	; ARP						
.equ adr_FREIGABE_ss					=SRAM_START+305	; Sekunde					
.equ adr_FREIGABE_mm					=SRAM_START+306	; Minute					
.equ adr_FREIGABE_hh					=SRAM_START+307	; 
.equ adr_FREIGABE_TAG					=SRAM_START+308	; 

.equ adr_ss10							=SRAM_START+310	; 10ms Sekunden				
.equ adr_ss								=SRAM_START+311	; Sekunden					
.equ adr_mm								=SRAM_START+312	; Minuten					
.equ adr_hh								=SRAM_START+313	; Stunden					
.equ adr_MESZ							=SRAM_START+314	; 0=MEZ 1=MESZ				
.equ adr_TAG							=SRAM_START+315	; TAG						
.equ adr_WOCHENTAG						=SRAM_START+316	; Wochentag (1=Mo 7=So)		
.equ adr_MONAT							=SRAM_START+317	; Monat						
.equ adr_JAHR							=SRAM_START+318	; JAHR						
.equ adr_BS_ss							=SRAM_START+319	; Betriebsstunden			
.equ adr_BS_mm							=SRAM_START+320
.equ adr_BS_hh							=SRAM_START+321
.equ adr_BS_TAG_L						=SRAM_START+322
.equ adr_BS_TAG_H						=SRAM_START+323

.equ adr_DUMMY0							=SRAM_START+324	; fr EDIT					
.equ adr_DUMMY1							=SRAM_START+325
.equ adr_DUMMY2							=SRAM_START+326
.equ adr_DUMMY3							=SRAM_START+327
.equ adr_DUMMY4							=SRAM_START+328
.equ adr_DUMMY5							=SRAM_START+329

.equ adr_HTML_DATA_LENGTH_L				=SRAM_START+330	; HTML DATA LENGTH			
.equ adr_HTML_DATA_LENGTH_H				=SRAM_START+331
.equ adr_HTML_CONTENENT_LENGTH_L		=SRAM_START+332	; HTML CONTENENT LENGTH		
.equ adr_HTML_CONTENENT_LENGTH_H		=SRAM_START+333

.equ adr_TCP_RX_VIEW_SourceMACaddr0		=SRAM_START+340	; TCP (Anzeige)					
.equ adr_TCP_RX_VIEW_SourceMACaddr1		=SRAM_START+341
.equ adr_TCP_RX_VIEW_SourceMACaddr2		=SRAM_START+342
.equ adr_TCP_RX_VIEW_SourceMACaddr3		=SRAM_START+343
.equ adr_TCP_RX_VIEW_SourceMACaddr4		=SRAM_START+344
.equ adr_TCP_RX_VIEW_SourceMACaddr5		=SRAM_START+345
.equ adr_TCP_RX_VIEW_IP4SourceIPaddr3	=SRAM_START+346	; TCP (Anzeige)					
.equ adr_TCP_RX_VIEW_IP4SourceIPaddr2	=SRAM_START+347
.equ adr_TCP_RX_VIEW_IP4SourceIPaddr1	=SRAM_START+348
.equ adr_TCP_RX_VIEW_IP4SourceIPaddr0	=SRAM_START+349
.equ adr_TCP_RX_VIEW_TCP_PORT_DEST_L	=SRAM_START+350	; TCP (Anzeige)					
.equ adr_TCP_RX_VIEW_TCP_PORT_DEST_H	=SRAM_START+351			
.equ adr_TCP_RX_VIEW_TCP_PORT_SOURCE_L	=SRAM_START+352	; TCP (Anzeige)					
.equ adr_TCP_RX_VIEW_TCP_PORT_SOURCE_H	=SRAM_START+353			
.equ adr_TCP_RX_VIEW_TCP_FLAGS			=SRAM_START+354

.equ adr_TCP_RX_VIEW_OK_IP4SourceIPaddr3=SRAM_START+355	; TCP (Anzeige)					
.equ adr_TCP_RX_VIEW_OK_IP4SourceIPaddr2=SRAM_START+356
.equ adr_TCP_RX_VIEW_OK_IP4SourceIPaddr1=SRAM_START+357
.equ adr_TCP_RX_VIEW_OK_IP4SourceIPaddr0=SRAM_START+358

.equ adr_TCP_ANZAHL_AUFRUFE_L			=SRAM_START+370	; Anzahl Aufrufe			
.equ adr_TCP_ANZAHL_AUFRUFE_H			=SRAM_START+371
.equ adr_TCP_RX_DATA_LENGTH_L			=SRAM_START+372	; TCP-DATA-Length (ohne Header)
.equ adr_TCP_RX_DATA_LENGTH_H			=SRAM_START+373
.equ adr_TCP_STACK_LENGTH_L				=SRAM_START+374
.equ adr_TCP_STACK_LENGTH_H				=SRAM_START+375
.equ adr_TCP_STACK_ZEIGER_L				=SRAM_START+376
.equ adr_TCP_STACK_ZEIGER_H				=SRAM_START+377
.equ adr_TCP_STACK_PAKET_LENGTH_L		=SRAM_START+378
.equ adr_TCP_STACK_PAKET_LENGTH_H		=SRAM_START+379
.equ adr_TCP_STACK_SEQ_LENGTH_L			=SRAM_START+380
.equ adr_TCP_STACK_SEQ_LENGTH_H			=SRAM_START+381
.equ adr_TCP_PAKET_COUNTER				=SRAM_START+382

.equ adr_1WIRE_STATUS					=SRAM_START+390	; 1WIRE	0=auf RP warten 1=RX					
.equ adr_1WIRE_BYTE						=SRAM_START+391	; 1WIRE						
.equ adr_1WIRE_BIT_COUNTER				=SRAM_START+392	; 1WIRE						
.equ adr_1WIRE_BYTE_COUNTER				=SRAM_START+393	; 1WIRE						
.equ adr_1WIRE_PS_EMPFANGEN				=SRAM_START+394	; 1WIRE-Prfsumme			
.equ adr_1WIRE_PS_BERECHNET				=SRAM_START+395	; 1WIRE-Prfsumme			
.equ adr_1WIRE_COUNTER_L				=SRAM_START+396	; 1WIRE-Prfsumme			
.equ adr_1WIRE_COUNTER_H				=SRAM_START+397	; 1WIRE-Prfsumme			
.equ adr_1WIRE_PS_ERROR_L				=SRAM_START+398	; 1WIRE-Prfsumme			
.equ adr_1WIRE_PS_ERROR_H				=SRAM_START+399	; 1WIRE-Prfsumme			

.equ adr_ANZAHL_KLINGEL					=SRAM_START+400		; KLINGEL				
.equ adr_ANZAHL_ANRUFE					=SRAM_START+401		; ANRUFE				
.equ adr_ENERGIESPAR_MODUS				=SRAM_START+402		; 
.equ adr_GEWITTER_PRO_STUNDE			=SRAM_START+403		; 
.equ adr_GEWITTER_PRO_TAG				=SRAM_START+404
.equ adr_NIEDERSCHLAG					=SRAM_START+405		; 
.equ adr_NIESELREGEN					=SRAM_START+406		;
.equ adr_RADIOAKTIVITAET				=SRAM_START+407		; 
.equ adr_WINDRICHTUNG					=SRAM_START+408		; 
.equ adr_WINDSTAERKE					=SRAM_START+409		; 
.equ adr_SONNE							=SRAM_START+410		; SONNE	(0..255)		
.equ adr_TEMPERATUR_AUSSEN_L			=SRAM_START+420		; Aussentemperatur		
.equ adr_TEMPERATUR_AUSSEN_H			=SRAM_START+421
.equ adr_DRUCK_ANALOG_L					=SRAM_START+422		; Luftdruck 			
.equ adr_DRUCK_ANALOG_H					=SRAM_START+423
.equ adr_DRUCK_DIGITAL_L				=SRAM_START+424		; Luftdruck 			
.equ adr_DRUCK_DIGITAL_H				=SRAM_START+425
.equ adr_SONNE_AUFGANG_mm				=SRAM_START+426	; SONNENAUFGANG				
.equ adr_SONNE_AUFGANG_hh				=SRAM_START+427	; SONNENAUFGANG				
.equ adr_SONNE_UNTERGANG_mm				=SRAM_START+428	; SONNENUNTERGANG			
.equ adr_SONNE_UNTERGANG_hh				=SRAM_START+429	; SONNENUNTERGANG
.equ adr_TEMPERATUR_RAUM_WZ_L			=SRAM_START+430		; RAUM WZ				
.equ adr_TEMPERATUR_RAUM_WZ_H			=SRAM_START+431
.equ adr_TEMPERATUR_RAUM_AZ_L			=SRAM_START+432 		; RAUM AZ				
.equ adr_TEMPERATUR_RAUM_AZ_H			=SRAM_START+433
.equ adr_TEMPERATUR_RAUM_KU_L			=SRAM_START+434 		; RAUM Kche			
.equ adr_TEMPERATUR_RAUM_KU_H			=SRAM_START+435
.equ adr_TEMPERATUR_RAUM_BA_L			=SRAM_START+436 		; RAUM BAD				
.equ adr_TEMPERATUR_RAUM_BA_H			=SRAM_START+437
.equ adr_TEMPERATUR_RAUM_FL_L			=SRAM_START+438 		; RAUM Flur				
.equ adr_TEMPERATUR_RAUM_FL_H			=SRAM_START+439
.equ adr_TEMPERATUR_RAUM_TH_L			=SRAM_START+440 		; RAUM Treppenhaus		
.equ adr_TEMPERATUR_RAUM_TH_H			=SRAM_START+441
.equ adr_TEMPERATUR_HZG_WZ_L			=SRAM_START+442 		; HEIZUNG WZ			
.equ adr_TEMPERATUR_HZG_WZ_H			=SRAM_START+443
.equ adr_TEMPERATUR_HZG_AZ_L			=SRAM_START+444 		; HEIZUNG AZ			
.equ adr_TEMPERATUR_HZG_AZ_H			=SRAM_START+445
.equ adr_TEMPERATUR_HZG_KU_L			=SRAM_START+446 		; HEIZUNG Kche			
.equ adr_TEMPERATUR_HZG_KU_H			=SRAM_START+447
.equ adr_TEMPERATUR_HZG_BA_L			=SRAM_START+448 		; HEIZUNG BAD			
.equ adr_TEMPERATUR_HZG_BA_H			=SRAM_START+449
.equ adr_TEMPERATUR_HAUS_KW_L			=SRAM_START+450 		; HAUS Kaltwasser		
.equ adr_TEMPERATUR_HAUS_KW_H			=SRAM_START+451
.equ adr_TEMPERATUR_HAUS_WW_L			=SRAM_START+452 		; HAUS Warmwasser		
.equ adr_TEMPERATUR_HAUS_WW_H			=SRAM_START+453
.equ adr_TEMPERATUR_HAUS_HZG_L			=SRAM_START+454 		; HAUS HZG				
.equ adr_TEMPERATUR_HAUS_HZG_H			=SRAM_START+455
.equ adr_RF_AUSSEN						=SRAM_START+460		; % Aussen				
.equ adr_RF_WZ							=SRAM_START+461 		; % RF WZ				
.equ adr_RF_AZ							=SRAM_START+462 		; % RF AZ				
.equ adr_RF_KU							=SRAM_START+463 		; % RF Kche			
.equ adr_RF_BA							=SRAM_START+464 		; % RF BAD				
.equ adr_RESERVE0_L						=SRAM_START+480 		; RESERVE-1				
.equ adr_RESERVE0_H						=SRAM_START+481
.equ adr_RESERVE1_L						=SRAM_START+482 		; RESERVE-1				
.equ adr_RESERVE1_H						=SRAM_START+483
.equ adr_RESERVE2_L						=SRAM_START+484 		; RESERVE-2				
.equ adr_RESERVE2_H						=SRAM_START+485
.equ adr_RESERVE3_L						=SRAM_START+486 		; RESERVE-3				
.equ adr_RESERVE3_H						=SRAM_START+487
.equ adr_RESERVE4_L						=SRAM_START+488 		; RESERVE-4				
.equ adr_RESERVE4_H						=SRAM_START+489
.equ adr_RESERVE_A						=SRAM_START+490
.equ adr_RESERVE_B						=SRAM_START+491
.equ adr_RESERVE_C						=SRAM_START+492
.equ adr_RESERVE_D						=SRAM_START+493
.equ adr_RESERVE_E						=SRAM_START+494

.equ adr_OW_MASTER_ERROR_ANZAHL			=SRAM_START+496
.equ adr_OW_MASTER_WARNUNG_ANZAHL		=SRAM_START+497
.equ adr_OW_ZAEHLER_RP_L				=SRAM_START+498		; fr Wartungszwecke (ZAEHLERWERTE)	
.equ adr_OW_ZAEHLER_RP_H				=SRAM_START+499		; fr Wartungszwecke (ZAEHLERWERTE)

.equ adr_EXTERN_TCP_PORT_DEST_L			=SRAM_START+500
.equ adr_EXTERN_TCP_PORT_DEST_H			=SRAM_START+501
.equ adr_EXTERN_TCP_PORT_L				=SRAM_START+502
.equ adr_EXTERN_TCP_PORT_H				=SRAM_START+503

.equ adr_IP_SERVER_EXTERN0				=SRAM_START+504	; externe IP z.B. Zeitserver	
.equ adr_IP_SERVER_EXTERN1				=SRAM_START+505
.equ adr_IP_SERVER_EXTERN2				=SRAM_START+506
.equ adr_IP_SERVER_EXTERN3				=SRAM_START+507

.equ adr_IP_OFFENTLICH0					=SRAM_START+512	; ffentlich IP ROUTER					
.equ adr_IP_OFFENTLICH1					=SRAM_START+513
.equ adr_IP_OFFENTLICH2					=SRAM_START+514
.equ adr_IP_OFFENTLICH3					=SRAM_START+515

.equ adr_MAC_ROUTER0					=SRAM_START+520	; MAC ROUTER aus ARP	
.equ adr_MAC_ROUTER1					=SRAM_START+521
.equ adr_MAC_ROUTER2					=SRAM_START+522
.equ adr_MAC_ROUTER3					=SRAM_START+523
.equ adr_MAC_ROUTER4					=SRAM_START+524
.equ adr_MAC_ROUTER5					=SRAM_START+525

.equ adr_TCP_PORT_OPEN					=SRAM_START+540
.equ adr_UDP_PORT_OPEN					=SRAM_START+541
.equ adr_LED_1WIRE_TIMER				=SRAM_START+542

.equ adr_FW_POINTER_L					=SRAM_START+560
.equ adr_FW_POINTER_H					=SRAM_START+561
.equ adr_FW_PORT_DESTINATION_L			=SRAM_START+564	; Firewall-Statistik	
.equ adr_FW_PORT_DESTINATION_H			=SRAM_START+565
.equ adr_FW_IP4SourceIPaddr3			=SRAM_START+566	; Firewall-Statistik	
.equ adr_FW_IP4SourceIPaddr2			=SRAM_START+567
.equ adr_FW_IP4SourceIPaddr1			=SRAM_START+568
.equ adr_FW_IP4SourceIPaddr0			=SRAM_START+569

.equ adr_FW_ANGRIFFE_UTP_L				=SRAM_START+580	; Anzahl 
.equ adr_FW_ANGRIFFE_UTP_H				=SRAM_START+581
.equ adr_FW_ANGRIFFE_L					=SRAM_START+582	; Anzahl 
.equ adr_FW_ANGRIFFE_H					=SRAM_START+583
.equ adr_FW_ANGRIFFE_NEU_L				=SRAM_START+584	; Anzahl 
.equ adr_FW_ANGRIFFE_NEU_H				=SRAM_START+585
.equ adr_FW_ANGRIFFE_SCHWER_L			=SRAM_START+586
.equ adr_FW_ANGRIFFE_SCHWER_H			=SRAM_START+587

.equ adr_1WIRE_DATA						=SRAM_START+700 	; 1WIRE-DATA 256 Bytes		

.equ adr_ARP_CHACHE_DATA				=SRAM_START+1000	; ARP-Data 360Bytes=12*30	

.equ adr_LOGBUCH_DATA					=SRAM_START+1500	; LOGBUCH 440=11Byte*40		

.equ adr_SRAM_CHECK_B					=SRAM_START+1999	; SRAM CHECK muss immer "S" sein	
.equ adr_ENC_DATA						=SRAM_START+2000	; ca. 1500 Bytes Data TX/RX	

.equ adr_SRAM_CHECK_C					=SRAM_START+3999	; SRAM CHECK muss immer "S" sein	
.equ adr_FW_DATA						=SRAM_START+4000	; Firewire-Data				

.equ adr_SRAM_CHECK_D					=SRAM_START+7999	; SRAM CHECK muss immer "S" sein	
.equ adr_TCP_STACK						=SRAM_START+8000	; TCP-DATA ca. 8kB			

.equ adr_SRAM_CHECK						=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	(RAMEND=16.639)
.equ adr_SRAM_END						=SRAM_START+16639
;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 jmp RESET 			; Reset										
.org 0x0002 jmp EXT_INT0 		; IRQ0										
.org 0x0004 jmp EXT_INT1 		; IRQ1										
.org 0x0006 jmp EXT_INT2 		; IRQ2										
.org 0x0008 jmp PCINTERRUPT0 	; PCINT0									
.org 0x000A jmp INTERRUPT_ERROR	; PCINT1									
.org 0x000C jmp INTERRUPT_ERROR ;jmp PCINT2 ; PCINT2						
.org 0x000E jmp INTERRUPT_ERROR ;jmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		 	; Watchdog Timeout							
.org 0x0012 jmp INTERRUPT_ERROR ;jmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 jmp INTERRUPT_ERROR ;jmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 jmp INTERRUPT_ERROR ;jmp TIM2_OVF 	; Timer2 Overflow			
.org 0x0018 jmp INTERRUPT_ERROR ;jmp TIM1_CAPT 	; Timer1 Capture			
.org 0x001A jmp INTERRUPT_ERROR ;jmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C jmp INTERRUPT_ERROR ;jmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E jmp TIM1_OVF 		; Timer1 Overflow							
.org 0x0020 jmp INTERRUPT_ERROR ;jmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 jmp INTERRUPT_ERROR ;jmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 jmp INTERRUPT_ERROR ;jmp TIM0_OVF 	; Timer0 Overflow			
.org 0x0026 jmp INTERRUPT_ERROR ;jmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 jmp USART0_RXC 		; USART0 RX Complete						
.org 0x002A jmp INTERRUPT_ERROR ;jmp USART0_UDRE ; USART0,UDR Empty			
.org 0x002C jmp INTERRUPT_ERROR ;jmp USART0_TXC ; USART0 TX Complete		
.org 0x002E jmp INTERRUPT_ERROR ;jmp ANA_COMP ; Analog Comparator			
.org 0x0030 jmp INTERRUPT_ERROR ;jmp ADC ; ADC Conversion Complete			
.org 0x0032 jmp INTERRUPT_ERROR ;jmp EE_RDY ; EEPROM Ready					
.org 0x0034 jmp INTERRUPT_ERROR ;jmp TWI ; 2-wire Serial					
.org 0x0036 jmp INTERRUPT_ERROR ;jmp SPM_RDY ; SPM Ready					
.org 0x0038 jmp INTERRUPT_ERROR ;jmp USART1_RXC ; USART1 RX Complete		
.org 0x003A jmp INTERRUPT_ERROR ;jmp USART1_UDRE ; USART1,UDR Empty			
.org 0x003C jmp INTERRUPT_ERROR ;jmp USART1_TXC ; USART1 TX Complete		
.org 0x003E jmp INTERRUPT_ERROR ;jmp TIM3_CAPT ; Timer3 Capture				
.org 0x0040 jmp INTERRUPT_ERROR ;jmp TIM3_COMPA ; Timer3 CompareA								
.org 0x0042 jmp INTERRUPT_ERROR ;jmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 jmp INTERRUPT_ERROR ;jmp TIM3_OVF 	; Timer3 Overflow			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Unkorrekter Interrupt Aufruf 													
;																				
; Neustart ber RESER															
;																				
INTERRUPT_ERROR:
	BEEP_ON
	CLI											; INTERRUPTS sperren	
	ldi temp,(ERROR_INTERRUPT)					; ERROR-CODE			
	call ERROR_SAVE_TEMP						; SAVE					
	jmp PROGRAMM_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diese Routine wird bei WDR-Zeitberschreitung aufgerufen, hier knnte man		
; sich z.B. den Fehler anzeigen lasen, oder DATEN in den EEPROM schreiben		
;																				
; Neustart ber WDR																
;																				
WDT:
	BEEP_ON
	CLI											; INTERRUPTS sperren	
	ldi temp,(ERROR_WDR)						; ERROR-CODE			
	call ERROR_SAVE_TEMP						; SAVE					
	jmp PROGRAMM_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
RESET:                        
	ldi temp, LOW(RAMEND)				; STACK initialisieren (16.639)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
;-------------------------------------------------------------------------------
	call WDR_INITIALISIERUNG			; WDR_INITIALISIERUNG								
	call SRAM_CLEAR						; SRAM_CLEAR										
	call PORT_CLEAR						; PORT_CLEAR										
	call REGISTER_CLEAR					; REGISTER_CLEAR									
	call STARTWERTE						; Startwerte										
	call LED_INITIALISIERUNG			; LED_INITIALISIERUNG								
	call TIMER1_INITIALISIERUNG			; TIMER1_INITIALISIERUNG							
	call USART_INITIALISIERUNG			; USART_INITIALISIERUNG								
	call SPI_INITIALISIERUNG			; SPI_INITIALISIERUNG								
	call OW_INITIALISIERUNG				; 1-WIRE INITIALISIERUNG							
	call EXT_INTERRUPT_INITIALISIERUNG	; EXT_INTERRUPT_INITIALISIERUNG						
	call LCD_INITIALISIERUNG			; LCD_INITIALISIERUNG								
	call EEPROM_LOAD					; EEPROM_KONFIGURATION_LADEN						
	call ENC_INITIALISIERUNG			; ENC_INITIALISIERUNG								
	call TEMPERATUR_MIN_MAX_INITIALISIERUNG; TEMPERATUR_MIN_MAX_INITIALISIERUNG				
	call TASTEN_INITIALISIERUNG			; TASTEN_INITIALISIERUNG							
	call PROGRAMM_CHECK					; PROGRAMM_CHECK									
	sei									; Interrupts freigeben								
;-------------------------------------------------------------------------------
	call EEPROM_SAVE
	call ARP_TX_REQUEST_ROUTER
	call ARP_TX_REQUEST_ROUTER
	call ARP_TX_REQUEST_ROUTER
	call BEEP_2X
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	call ENC_DATA_IM_BUFFER_C	; Daten vorhanden, ja C=1	
	brcc LOOP_w
	call ENC_RX
	call ENC_RX_AUSWERTUNG
	jmp LOOP
;-------------------------------------------------------------------------------
LOOP_w:
	call PROGRAMM_CHECK
	call TASTEN_ABFRAGE
	call MENUE
	call TASTEN_WAIT

	call LOOP_TAG
	call LOOP_hh
	call LOOP_mm
	call LOOP_ss	
jmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP_ss:
	LDS temp,(adr_FREIGABE_SS)				; sekndlich
	STS(adr_FREIGABE_SS),NULL
	tst temp
	brne LOOP_ss_RUN
	ret
;-------------------------------------------------------------------------------
LOOP_ss_RUN:
	call OFFENTLICHE_IP_AUSLESEN			; OFFENTLICHE_IP	
	call UTP_DNS_SERVER_EXTERN				; DNS SERVER EXTERN	

	call ENC_MAC_ADRESSE_CHECK
	call ARP_TX_REQUEST_SCAN

	call TEMPERATUR_MAX
	call TEMPERATUR_MIN

	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP_mm:
	LDS temp,(adr_FREIGABE_mm)
	STS(adr_FREIGABE_mm),NULL
	tst temp
	brne LOOP_mm_RUN
	ret
;-------------------------------------------------------------------------------
LOOP_mm_RUN:
	call ARP_TX_REQUEST_ROUTER
	call SERIELL_TX_OFFENTLICHE_IP
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP_hh:
	LDS temp,(adr_FREIGABE_hh)
	STS(adr_FREIGABE_hh),NULL
	tst temp
	brne LOOP_hh_RUN
	ret
;-------------------------------------------------------------------------------
LOOP_hh_RUN:
	call FUNCTION_IP_SERVER_EXTERN_NULL	; NULL	
	call FUNCTION_IP_OFFENTLICH_NULL	; NULL	
	call TEMPERATURSTATISTIK_STUNDE
	call EEPROM_SAVE				; SAVE		
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP_TAG:
	LDS temp,(adr_FREIGABE_TAG)
	STS(adr_FREIGABE_TAG),NULL
	tst temp
	brne LOOP_TAG_RUN
	ret
;-------------------------------------------------------------------------------
LOOP_TAG_RUN:
	call TEMPERATURSTATISTIK_TAG
	call EEPROM_SAVE				; SAVE		
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ENC.asm"						; ENC-INITIALISIERUNGE NC28J60 Definitionen	
.include "ENC_RX.asm"					; ENC-RX						
.include "ENC_TX.asm"					; ENC-TX						
.include "NET.asm"						; Definitionen					
.include "NET_FUNC.asm"					; Funktionen					
.include "NET_ARP.asm"					; ARP							
.include "NET_UDP_DNS.asm"				; UDP							
.include "NET_ICMP.asm"					; ICMP							
.include "NET_TCP_RX.asm"				; TCP							
.include "NET_TCP_TX.asm"				; TCP							
.include "NET_TCP_ZEIT.asm"				; TCP							
.include "NET_TCP_OFFENTLICHE_IP.asm"	; TCP 							
.include "NET_TCP_WEB.asm"				; TCP							
.include "NET_HTML.asm"					; HTTP / HTML					
.include "NET_HTML_A.asm"				; HTTP / HTML					
.include "NET_HTML_B.asm"				; HTTP / HTML					
.include "NET_HTML_C.asm"				; HTTP / HTML					
.include "SPI.asm"						; SPI							
.include "LCD.asm"						; LCD							
.include "LCD_ANZEIGE.asm"				; LCD							
.include "LCD_TEXTE.asm"				; LCD							
.include "LCD_KURZ.asm"					; LCD							
.include "MENUE.asm"					; MENUE							
.include "SONSTIGES.asm"				; sonstiges						
.include "USART_DEBUG.asm"				; DEBUG							
.include "USART.asm"					; USART							
.include "OW.asm"						; 1WIRE							
.include "TIMER.asm"					; TIMER							
.include "LOGBUCH.asm"					; LOGBUCH						
.include "FW.asm"						; Firewall						
.include "EEPROM.asm"					; EEPROM						
.include "TASTEN.asm"					; TASTEN						
.include "SERIELL.asm"					; output serielle Daten			
.include "WAIT.asm"						; WAIT							
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "WEBSERVER",0
TEXT_BEGRUESSUNG_2:
.db "ATmega1284p-16 ",0
TEXT_BEGRUESSUNG_3:
.db "ENC28J60 ",0
TEXT_BEGRUESSUNG_4:
.db "05.12.2019 ",0

DNS_ZEITSERVER:
.db "ntp1.fau.de",0
;.db "216.146.43.71",0
;.db "google.com",0,0 

DNS_CHECKIP:
.db "checkip.dyndns.com",0,0


IP_GET:
.db "GET / HTTP/1.1"
.db "Host: checkip.dyndns.com"
.db "User-Agent: Mozilla/5.0 (Windows NT 5.1; rv:52.0) Gecko/20100101 Firefox/52.0 "
.db "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8 "
.db "Accept-Language: de,en-US;q=0.7,en;q=0.3"
.db "Accept-Encoding: gzip, deflate"
.db "DNT: 1"
.db "Connection: keep-alive"
.db "Upgrade-Insecure-Requests: 1",13,10,13,10,255,255

IP_SEARCH_STRING:
.db "Address",255
